Index: trunk/LMDZ.GENERIC/libf/aeronostd/photochemistry_asis.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/aeronostd/photochemistry_asis.F90	(revision 2541)
+++ trunk/LMDZ.GENERIC/libf/aeronostd/photochemistry_asis.F90	(revision 2542)
@@ -1843,25 +1173,394 @@
 
       do l = 1,lswitch-1
-         zycol(l, igcm_co2)     = c(l,i_co2)/dens(l) 
-         zycol(l, igcm_co)      = c(l,i_co)/dens(l) 
-         zycol(l, igcm_o)       = c(l,i_o)/dens(l) 
-         zycol(l, igcm_o1d)     = c(l,i_o1d)/dens(l)
-         zycol(l, igcm_o2)      = c(l,i_o2)/dens(l) 
-         zycol(l, igcm_o3)      = c(l,i_o3)/dens(l) 
-         zycol(l, igcm_h)       = c(l,i_h)/dens(l)  
-         zycol(l, igcm_h2)      = c(l,i_h2)/dens(l) 
-         zycol(l, igcm_oh)      = c(l,i_oh)/dens(l) 
-         zycol(l, igcm_ho2)     = c(l,i_ho2)/dens(l) 
-         zycol(l, igcm_h2o2)    = c(l,i_h2o2)/dens(l)
-         zycol(l, igcm_h2o_vap) = c(l,i_h2o)/dens(l)
-         zycol(l, igcm_n)       = c(l,i_n)/dens(l)
-         zycol(l, igcm_n2d)     = c(l,i_n2d)/dens(l)
-         zycol(l, igcm_no)      = c(l,i_no)/dens(l)
-         zycol(l, igcm_no2)     = c(l,i_no2)/dens(l)
-         zycol(l, igcm_n2)      = c(l,i_n2)/dens(l)
+         zycol(l,:)  = c(l,:)/dens(l) 
       end do 
 
       end subroutine chimtogcm
 
+!*****************************************************************
+
+    subroutine split_str(line,words,n,nmax)
+
+!*****************************************************************
+
+        implicit none
+        character(*), intent(in)  :: line
+        integer,      intent(in)  :: nmax
+        character(*), intent(out) :: words(nmax)
+        integer,      intent(out) :: n          ! number of words at the end
+        integer :: ios
+        character(100) :: buf(100)  ! large buffer!
+    
+        n = 0
+        do
+            n = n + 1
+            read(line,*,iostat=ios) buf(1:n)  ! use list-directed input
+            if (ios==0) then
+                words(1:n) = buf(1:n)   ! if success, copy to the original array
+            else
+                n = n-1
+                exit       ! if all the words are obtained, finish
+            endif
+            if (n>nmax) then
+              print*,'Error in split_str: to much words'
+              print*,'limit = ',nmax
+              print*,'change it, if you want, with increasing nmax'
+              stop
+            end if
+        enddo
+    end subroutine split_str
+
+!*****************************************************************
+
+    subroutine count_react(reactfile,nlines,nreact,nrtype,nb_hv,nb_pfunc1,nb_pfunc2,nb_pfunc3)
+
+!*****************************************************************
+
+        use types_asis, only : nb_phot_hv_max
+
+        implicit none
+        character(*), intent(in)     :: reactfile ! name of the file to read 
+        integer,      intent(inout)  :: nlines    ! number of lines in the file
+        integer,      intent(out)    :: nreact    ! real number of reaction
+        integer,      intent(inout)  :: nrtype    ! number of reaction for calculation
+        integer,      intent(inout)  :: nb_hv, nb_pfunc1, nb_pfunc2, nb_pfunc3
+
+        ! local
+        character(len = 50) :: reactline          ! all reactants of one reaction
+        character(len = 50) :: prodline           ! all produts of one reaction
+        integer             :: typerate           ! get the type of the rate reaction coefficient (pfunc_i)
+        integer             :: nwp                ! number of products for a reaction
+        integer,parameter   :: nmax = 5           ! number max of reactants or products
+        character(len = 24) :: words(nmax)        ! to get words in reactants and products line
+        integer             :: ierr
+
+        nreact     = 0
+
+        open(402, form = 'formatted', status = 'old',                &
+              file ='chemnetwork/'//trim(reactfile),iostat=ierr)
+
+        if (ierr /= 0) THEN
+           write(*,*)'Error : cannot open chemical reaction file : chemnetwork/'//trim(reactfile)
+           write(*,*)'It should be in your simulation directory in chemnetwork directory'
+           write(*,*)'   You can change the input chemical reactions file name in'
+           write(*,*)'   callphys.def with:'
+           write(*,*)'   monoreact=filename or bimolreact=filename or quadrareact=filename'
+           write(*,*)'   depending on what chemical reaction type it is'
+           stop
+        end if
+    
+        do
+          read(402,'(A,A,I2)',iostat=ierr) reactline, prodline, typerate
+          if (ierr<0) exit
+          nlines = nlines + 1
+          if (reactline(1:1)/='!' .and. reactline(1:1)/='') then
+            ! count the number of reaction
+            nreact = nreact + 1
+            call split_str(prodline,words,nwp,nmax)
+            nrtype = nrtype + 1
+            ! check three product reaction
+            if (nwp>2 .and. trim(words(1))/=trim(words(2)) &
+                      .and. trim(words(1))/=trim(words(3)) &
+                      .and. trim(words(2))/=trim(words(3))) nrtype = nrtype + 1
+
+            ! count the number of each rate reaction coefficient type
+            if (typerate==0) then
+              nb_hv = nb_hv + 1
+              nb_phot_hv_max = nb_phot_hv_max + 1
+              if (nwp>2 .and. trim(words(1))/=trim(words(2)) &
+                        .and. trim(words(1))/=trim(words(3)) &
+                        .and. trim(words(2))/=trim(words(3))) nb_phot_hv_max = nb_phot_hv_max + 1
+            else if (typerate==1) then
+              nb_pfunc1 = nb_pfunc1 + 1
+            else if (typerate==2) then
+              nb_pfunc2 = nb_pfunc2 + 1
+            else if (typerate==3) then
+              nb_pfunc3 = nb_pfunc3 + 1
+            else
+              print*, 'Error in indice: wrong index coefficient rate line ',nlines
+              print*, 'in file : chemnetwork/'//trim(reactfile)
+              print*, 'It should be 0 for photolysis reations and 1 or 2 for the others'
+              print*, 'And not : ', typerate
+              stop
+            end if
+
+          end if
+
+        end do
+
+        close(402)
+
+    end subroutine count_react
+
+!*****************************************************************
+
+    subroutine get_react(reactfile,nlines,nreact,rtype,third_body,three_prod, &
+                         nrtype,specheck,specheckr,specheckp,typeindice,nbq,  &
+                         init_nb_pfunc1,init_nb_pfunc2,init_nb_pfunc3)
+
+!*****************************************************************
+
+        use types_asis
+        use tracer_h
+        use chimiedata_h, only: indexchim
+        use callkeys_mod, only: jonline
+
+        implicit none
+        character(*), intent(in)     :: reactfile          ! name of the file to read 
+        integer,      intent(in)     :: nlines             ! number of lines in the file
+        integer,      intent(in)     :: nreact             ! real number of reaction in the file
+        integer,      intent(inout)  :: rtype(nreact)      ! reaction rate type
+        integer,      intent(inout)  :: third_body(nreact) ! if the reaction have a third body: index of the third body, else zero
+        logical,      intent(inout)  :: three_prod(nreact) ! if the reaction have a three defferent proucts egal .true.
+        integer,      intent(out)    :: nrtype             ! number of calculation reactions
+        integer,      intent(inout)  :: specheck(nesp)     ! to count the species of traceur.def in reactions file
+        integer,      intent(inout)  :: specheckr(nesp)    ! to count the reactant species of traceur.def in reactions file
+        integer,      intent(inout)  :: specheckp(nesp)    ! to count the product species of traceur.def in reactions file
+        character(*), intent(in)     :: typeindice         ! reaction type (v3, v4 or vphot)
+        integer,      intent(inout)  :: nbq                ! number of species in reactions file
+        integer,      intent(inout)  :: init_nb_pfunc1     ! in : initial value of nb_pfunc1 - out : final value of nb_pfunc1
+        integer,      intent(inout)  :: init_nb_pfunc2     ! in : initial value of nb_pfunc2 - out : final value of nb_pfunc2
+        integer,      intent(inout)  :: init_nb_pfunc3     ! in : initial value of nb_pfunc3 - out : final value of nb_pfunc3
+
+        ! local
+        character(len = 50)  :: reactline                  ! all reactants of one reaction
+        character(len = 50)  :: prodline                   ! all produts of one reaction
+        integer              :: nwr                        ! number of reactants for a reaction
+        integer              :: nwp                        ! number of products for a reaction
+        integer,parameter    :: nmax = 5                   ! number max of reactants or products
+        character(len = 24)  :: words(nmax)                ! to get words in reactants and products line
+        real                 :: nindice(2*nmax)            ! stoichiometry of species (for indice variables)
+        integer              :: iindice(2*nmax)            ! indice of species (for indice variables)
+        character(len = 500) :: paramline                  ! line of reactions parameters
+        character(len = 50)  :: reactants(nreact,nmax)     ! reactions reactants
+        character(len = 50)  :: products(nreact,nmax)      ! reactions products
+        logical              :: spedouble                  ! check if a specie appears twice in reactants or products
+        integer              :: ierr, ilines, ireact, i_dummy, iw, iwhere, i
+        integer              :: nb_hv, nb_pfunc1, nb_pfunc2, nb_pfunc3
+
+        i_dummy   = 1
+        nrtype    = 0
+        ireact    = 0
+        nb_hv     = 0
+        nb_pfunc1 = init_nb_pfunc1
+        nb_pfunc2 = init_nb_pfunc2
+        nb_pfunc3 = init_nb_pfunc3
+
+        open(402, form = 'formatted', status = 'old',                &
+              file ='chemnetwork/'//trim(reactfile),iostat=ierr)
+
+        if (ierr /= 0) THEN
+           write(*,*)'Error : cannot open chemical reaction file : chemnetwork/'//trim(reactfile)
+           write(*,*)'It should be in your simulation directory in chemnetwork directory'
+           write(*,*)'   You can change the input chemical reactions file name in'
+           write(*,*)'   callphys.def with:'
+           write(*,*)'   monoreact=filename or bimolreact=filename or quadrareact=filename'
+           write(*,*)'   depending on what chemical reaction type it is'
+           stop
+        end if
+
+        do ilines=1,nlines
+          paramline = ''
+
+          read(402,'(A,A,A)') reactline, prodline, paramline
+
+          ! continue only if it's not a comment line
+          if (reactline(1:1)/='!' .and. reactline(1:1)/='') then
+
+            ! increment number of reactions and init
+            ireact = ireact + 1
+        !!!!!!!!!!!!!!!!!!!!!!!!!!! for fill indice part
+            nrtype = nrtype + 1
+            nindice(:) = 0.0
+            iindice(:) = i_dummy
+        !!!!!!!!!!!!!!!!!!!!!!!!!!! end
+            ! get indice, rate type and parameters
+            if (trim(paramline)=='') then
+              print*, 'Error in reactfile: where are the parameters - line',ilines
+              stop
+            else
+              read(paramline,*) rtype(ireact)
+              if (rtype(ireact)==1) then
+                nb_pfunc1 = nb_pfunc1 + 1
+                read(paramline,*) rtype(ireact), pfunc1_param(nb_pfunc1)
+              else if (rtype(ireact)==0) then
+                nb_hv = nb_hv + 1
+                if (jonline) then
+                  read(paramline,'(I5,A,A)') rtype(ireact), jlabel(nb_hv,1), jparamline(nb_hv)
+                else
+                  read(paramline,*) rtype(ireact), jlabel(nb_hv,1)
+                end if
+              else if (rtype(ireact)==2) then
+                nb_pfunc2 = nb_pfunc2 + 1
+                read(paramline,*) rtype(ireact), pfunc2_param(nb_pfunc2)
+              else if (rtype(ireact)==3) then
+                nb_pfunc3 = nb_pfunc3 + 1
+                read(paramline,*) rtype(ireact), pfunc3_param(nb_pfunc3)
+              end if
+            end if
+        
+            ! get reactants
+            call split_str(reactline,words,nwr,nmax)
+            if (rtype(ireact)==0) jlabel(nb_hv,2) = words(1)
+            ! loop on reactants
+            do iw=1,nwr
+              ! store reactants in variable 'reactants'
+              reactants(ireact,iw) = trim(words(iw))
+              ! check third body and exit reactants loop
+              if (reactants(ireact,iw)=='M') then
+                if (iw==nwr) then
+                  exit
+                else if (iw==nwr-1) then
+                  third_body(ireact) = indexchim(words(iw+1))
+                  exit
+                else
+                  print*, 'Error in reactfile: just only one specie can be after M corresponding to the third body - line',ilines
+                  stop
+                end if
+              end if
+              if (trim(words(iw))/='hv' .and. trim(words(iw))/='dummy') then
+                iwhere = indexchim(words(iw))
+                ! check if species are chemical tracers
+                if (iwhere>nesp) then
+                  print*, 'Error: in ', trim(reactfile)
+                  print*, 'check if the specie', trim(words(iw)),' is include into chemical tracers in traceur.def'
+                  stop
+                end if
+                ! to count the species used in 'reactfile'
+                if (specheck(iwhere)==0) then
+                  specheckr(iwhere) = 1
+                  specheck(iwhere) = 1
+                  nbq = nbq + 1
+                else if (specheckr(iwhere)==0) then
+                  specheckr(iwhere) = 1
+                end if
+        
+        !!!!!!!!!!!!!!!!!!! for fill indice part
+                ! fill stochiometry and indice of rection species depending of reaction type
+                if (trim(typeindice)=='v3') then
+                  nindice(1) = 2.0
+                  iindice(1) = indexchim(words(iw))
+                  if (nwr>3 .or. nwr<2) print*, 'Error in reactfile: wrong number of reactants for v3 reaction line',ilines
+                  if (nwr==2 .and. trim(words(1))/=trim(words(2))) print*, 'Error in reactfile: both reactants should be the same for v3 reaction line',ilines
+                else if (trim(typeindice)=='v4') then
+                  nindice(iw) = 1.0
+                  iindice(iw) = indexchim(words(iw))
+                else if (trim(typeindice)=='vphot') then
+                  nindice(1) = 1.0
+                  if (iw>2) then
+                    print*, 'Something weird in your photolysis reaction'
+                    print*, 'You should have 1 reactants and hv'
+                    print*, 'Reactants are: ',words
+                    stop
+                  end if
+                  iindice(1) = indexchim(words(iw))
+                end if
+        !!!!!!!!!!!!!!!!!!! end
+        
+              end if
+            end do
+
+            ! same as reactants but for the products
+            call split_str(prodline,words,nwp,nmax)
+            do iw=1,nwp
+              spedouble = .false.
+              products(ireact,iw) = trim(words(iw))
+              if (trim(words(iw))/='hv' .and. trim(words(iw))/='dummy' .and. trim(words(iw))/='M') then
+                iwhere = indexchim(words(iw))
+                if (iwhere>nesp) then
+                  print*, 'Error: in ', trim(reactfile)
+                  print*, 'check if the specie', trim(words(iw)),' is include into chemical tracers in traceur.def'
+                  stop
+                end if
+                if (specheck(iwhere)==0) then
+                  specheckp(iwhere) = 1
+                  specheck(iwhere) = 1
+                  nbq = nbq + 1
+                else if (specheckp(iwhere)==0) then
+                  specheckp(iwhere) = 1
+                end if
+        
+        !!!!!!!!!!!!!!!!!!!!!!!!!! for fill indice part
+                if (trim(typeindice)=='v3' .or. trim(typeindice)=='vphot') then
+                    iindice(1+iw) = indexchim(words(iw))
+                  do i=1,iw-1
+                    if (iindice(1+iw)==iindice(1+i)) then
+                      nindice(1+i)  = nindice(1+i) + 1.0
+                      iindice(1+iw) = i_dummy
+                      spedouble = .true.
+                    end if
+                  end do
+                  if (.not. spedouble) nindice(1+iw) = 1.0
+                else if (trim(typeindice)=='v4') then
+                  iindice(2+iw) = indexchim(words(iw))
+                  do i=1,iw-1
+                    if (iindice(2+iw)==iindice(2+i)) then
+                      nindice(2+i)  = nindice(2+i) + 1.0
+                      iindice(2+iw) = i_dummy
+                      spedouble = .true.
+                    end if
+                  end do
+                  if (.not. spedouble) nindice(2+iw) = 1.0
+                end if
+        !!!!!!!!!!!!!!!!!!!!!!!!!!! end
+              else
+                print*, 'Error: no hv, dummy or M in products'
+                stop
+              end if
+            end do
+
+            ! fill indice variables
+            if (trim(typeindice)=='v3') then
+              if (nindice(4)/=0.0) then ! reaction with 3 products
+                if (nindice(3)==0.0) then ! 2 are the same species
+                  indice_3(nrtype) = z3spec(nindice(1), iindice(1), nindice(2), iindice(2), nindice(4), iindice(4))
+                else ! reaction with 3 different products
+                  indice_3(nrtype) = z3spec(nindice(1)/2., iindice(1), nindice(2), iindice(2), 0.0, i_dummy)
+                  nrtype = nrtype + 1
+                  indice_3(nrtype) = z3spec(nindice(1)/2., iindice(1), nindice(3), iindice(3), nindice(4), iindice(4))
+                  three_prod(ireact) = .true.
+                end if
+              else ! reaction with 1 or 2 products
+                indice_3(nrtype) = z3spec(nindice(1), iindice(1), nindice(2), iindice(2), nindice(3), iindice(3))
+              end if
+            else if (trim(typeindice)=='v4') then
+              if (nindice(5)/=0.0) then ! reaction with 3 products
+                if (nindice(4)==0.0) then ! 2 are the same species
+                  indice_4(nrtype) = z4spec(nindice(1), iindice(1), nindice(2), iindice(2), nindice(3), iindice(3), nindice(5), iindice(5))
+                else ! reaction with 3 different products
+                  indice_4(nrtype) = z4spec(nindice(1)/2., iindice(1), nindice(2)/2., iindice(2), nindice(3), iindice(3), nindice(4)/2., iindice(4))
+                  nrtype = nrtype + 1
+                  indice_4(nrtype) = z4spec(nindice(1)/2., iindice(1), nindice(2)/2., iindice(2), nindice(5), iindice(5), nindice(4)/2., iindice(4))
+                  three_prod(ireact) = .true.
+                end if
+              else ! reaction with 1 or 2 products
+                indice_4(nrtype) = z4spec(nindice(1), iindice(1), nindice(2), iindice(2), nindice(3), iindice(3), nindice(4), iindice(4))
+              end if
+            else if (trim(typeindice)=='vphot') then
+              if (nindice(4)/=0.0) then ! reaction with 3 products
+                if (nindice(3)==0.0) then ! 2 are the same species
+                  indice_phot(nrtype) = z3spec(nindice(1), iindice(1), nindice(2), iindice(2), nindice(4), iindice(4))
+                else ! reaction with 3 different products
+                  indice_phot(nrtype) = z3spec(nindice(1)/2., iindice(1), nindice(2), iindice(2), 0.0, i_dummy)
+                  nrtype = nrtype + 1
+                  indice_phot(nrtype) = z3spec(nindice(1)/2., iindice(1), nindice(3), iindice(3), nindice(4), iindice(4))
+                  three_prod(ireact) = .true.
+                end if
+              else ! reaction with 1 or 2 products
+                indice_phot(nrtype) = z3spec(nindice(1), iindice(1), nindice(2), iindice(2), nindice(3), iindice(3))
+              end if
+            end if
+        
+          end if
+
+        end do
+
+        init_nb_pfunc1 = nb_pfunc1
+        init_nb_pfunc2 = nb_pfunc2
+        init_nb_pfunc3 = nb_pfunc3
+
+        close(402)
+
+    end subroutine get_react
+
 end subroutine photochemistry_asis
-
Index: trunk/LMDZ.GENERIC/libf/aeronostd/photolysis_asis.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/aeronostd/photolysis_asis.F90	(revision 2541)
+++ trunk/LMDZ.GENERIC/libf/aeronostd/photolysis_asis.F90	(revision 2542)
@@ -1,7 +1,7 @@
 !==========================================================================
 
-      subroutine photolysis_asis(nlayer, ngrid,                                 &
-                                 lswitch, press, temp, sza, fractcol, tauref,   &
-                                 zmmean, dist_sol, rmco2, rmo3, v_phot)
+      subroutine photolysis_asis(nlayer, ngrid,                    &
+                                 lswitch, press, temp, sza,fractcol, tauref,   &
+                                 zmmean, dist_sol, rmco2, rmo3, rmch4, v_phot, e_phot, nreact, three_prod)
 
 !==========================================================================
@@ -9,8 +9,10 @@
       use comcstfi_mod
       use callkeys_mod
+      use types_asis
+      use chimiedata_h
 
       implicit none
 
-#include "chimiedata.h" 
+!#include "chimiedata.h" 
 
 !==========================================================================
@@ -19,5 +21,5 @@
        
       integer, intent(in) :: nlayer ! number of atmospheric layers
-      integer,intent(in) :: ngrid   ! number of atmospheric columns
+      integer, intent(in) :: ngrid  ! number of atmospheric columns
       integer :: lswitch            ! interface level between chemistries
       real :: press(nlayer)         ! pressure (hPa)
@@ -26,8 +28,11 @@
       real :: fractcol              ! day fraction
       real :: tauref                ! optical depth at 7 hpa
-      real :: zmmean(nlayer)        ! mean molecular mass (g)
+      real :: zmmean(nlayer)        ! mean molecular mass (g/mol)
       real :: dist_sol              ! sun distance (AU) 
       real :: rmco2(nlayer)         ! co2 mixing ratio
       real :: rmo3(nlayer)          ! ozone mixing ratio
+      real :: rmch4(nlayer)         ! ch4 mixing ratio
+      integer, intent(in) :: nreact             ! number of reactions in reactions files
+      logical, intent(in) :: three_prod(nreact) ! if the reaction have a three defferent products egal .true.
 
 !==========================================================================
@@ -36,4 +41,5 @@
 
       real (kind = 8), dimension(nlayer,nb_phot_max) :: v_phot
+      real (kind = 8), dimension(nlayer,nb_phot_max) :: e_phot
 
 !==========================================================================
@@ -42,24 +48,21 @@
 
       integer :: icol, ij, indsza, indtau, indcol, indozo, indtemp,     &
-                 iozo, isza, itau, it, l
-
-      integer :: j_o2_o, j_o2_o1d, j_co2_o, j_co2_o1d, j_o3_o1d,        &
-                 j_o3_o, j_h2o, j_hdo, j_h2o2, j_ho2, j_no, j_no2,      &
-                 j_hno3, j_hno4,                                        &
-                 j_ch4_ch3_h, j_ch4_1ch2_h2, j_ch4_3ch2_h_h,            &
-                 j_ch4_ch_h2_h, j_ch3o2h, j_ch2o_hco, j_ch2o_co,        &
-                 j_ch3oh, j_c2h6, j_hcl, j_hocl, j_clo, j_so2, j_so,    &
-                 j_h2s, j_so3
+                 iozo, isza, itau, it, ich4, indch4, l, nb_phot 
 
       real :: col(nlayer)                 ! overhead air column   (molecule cm-2)
       real :: colo3(nlayer)               ! overhead ozone column (molecule cm-2)
-      real :: poids(2,2,2,2,2)            ! 5D interpolation weights 
+      real :: colch4(nlayer)               ! overhead CH4 column (molecule cm-2)
+      real :: tauch4(nlayer)               ! estimation of optical depth by CH4
+      real :: ch4_equ(nlayer)               ! equivalent constant mixing ratio for the same column of CH4
+      real :: poids(2,2,2,2,2,2)          ! 6D interpolation weights 
       real :: tref                        ! temperature  at 1.9 hPa in the gcm (K)
       real :: table_temp(ntemp)           ! temperatures at 1.9 hPa in jmars   (K)
-      real :: cinf, csup, cicol, ciozo, cisza, citemp, citau
+      real :: ch4ref                      ! ch4 mixing ratio at top of the atmosphere
+      real :: cinf, csup, cicol, ciozo, cisza, citemp, citau, cich4
       real :: colo3min, dp, coef
       real :: ratio_o3(nlayer)
       real :: tau
       real :: j(nlayer,nd)
+      real :: e(nlayer,nd)
 
 !==========================================================================
@@ -73,8 +76,11 @@
 !==========================================================================
       
-      table_temp(1) = 226.2
-      table_temp(2) = 206.2
-      table_temp(3) = 186.2
-      table_temp(4) = 169.8
+!      table_temp(1) = 226.2
+!      table_temp(2) = 206.2
+!      table_temp(3) = 186.2
+!      table_temp(4) = 169.8
+
+!      table_temp(2) = 186.2
+      table_temp(1) = 176.2
 
 !==========================================================================
@@ -90,6 +96,12 @@
          end if
       end do
-      cisza = (sza - szatab(indsza))  &
+
+      if(nsza.eq.1) then
+        cisza = 0.
+        indsza=1
+      else
+        cisza = (sza - szatab(indsza))  &
              /(szatab(indsza + 1) - szatab(indsza))
+      endif
 
 !==========================================================================
@@ -108,43 +120,100 @@
          end if
       end do
-      citau = (tau - tautab(indtau))     &
+
+      if(ntau.eq.1) then
+        citau=0.
+        indtau=1
+      else
+        citau = (tau - tautab(indtau))     &
              /(tautab(indtau + 1) - tautab(indtau))
-
-!==========================================================================
-!     co2 and ozone columns
+      endif
+
+
+
+!==========================================================================
+!     air and ozone columns
 !==========================================================================
 
 !     co2 column at model top (molecule.cm-2)
 
-      col(lswitch-1) = 6.022e22*rmco2(lswitch-1)*press(lswitch-1)*100.  &
-                       /(zmmean(lswitch-1)*g)
+!      col(lswitch-1) = 6.022e22*rmco2(lswitch-1)*press(lswitch-1)*100.  &
+!                       /(zmmean(lswitch-1)*g)
+      col(lswitch-1) = 6.022e22*press(lswitch-1)*100./(zmmean(lswitch-1)*g)
+
 
 !     ozone column at model top
 
       colo3(lswitch-1) = 0.
-
 !     co2 and ozone columns for other levels (molecule.cm-2)
 
       do l = lswitch-2,1,-1
          dp = (press(l) - press(l+1))*100.
-         col(l) = col(l+1) + (rmco2(l+1) + rmco2(l))*0.5   &
-                             *6.022e22*dp/(zmmean(l)*g)
+!         col(l) = col(l+1) + (rmco2(l+1) + rmco2(l))*0.5   &
+!                             *6.022e22*dp/(zmmean(l)*g)
+         col(l) = col(l+1) +  6.022e22*dp/(zmmean(l)*g)
          col(l) = min(col(l), colairtab(1))
          colo3(l) = colo3(l+1) + (rmo3(l+1) + rmo3(l))*0.5 &
                                  *6.022e22*dp/(zmmean(l)*g)
-      end do
-
-!     ratio ozone column/minimal theoretical column (0.1 micron-atm) 
-
-!     ro3 = 7.171e-10 is the o3 mixing ratio for a uniform
-!     profile giving a column 0.1 micron-atmosphere at
-!     a surface pressure of 10 hpa.
+
+      end do
+
+!     ratio ozone column/minimal theoretical column (10 micron-atm) 
+
+!     ro3 = 1.227e-10 is the o3 mixing ratio for a uniform
+!     profile giving a column 10 micron-atmosphere at
+!     a surface pressure of 1 bar.
 
       do l = 1,lswitch-1
-         colo3min    = col(l)*7.171e-10
+!         colo3min    = col(l)*7.171e-10
+         colo3min    = col(l)*1.227e-10*(g/9.81)*(mugaz/28)
          ratio_o3(l) = colo3(l)/colo3min
-         ratio_o3(l) = min(ratio_o3(l), table_ozo(nozo)*10.)
-         ratio_o3(l) = max(ratio_o3(l), 1.)
-      end do
+         ratio_o3(l) = min(ratio_o3(l), table_ozo(nozo))
+         ratio_o3(l) = max(ratio_o3(l), 0.)
+      end do
+
+!      print*,'co3(1)=',colo3(1)
+!      print*,'col(1)=',col(1)
+!      print*,'ratio_o3(1)=',ratio_o3(1)
+!      print*,'maxval(ratio_o3)=',maxval(ratio_o3(:))
+!      print*,'maxval(ozo)=',table_ozo(nozo)/10.
+
+!==========================================================================
+!     ch4 dependence
+!==========================================================================
+
+!     1) search for temperature at 1.9 hPa (tref): vertical
+!     interpolation
+
+      ch4ref = rmch4(lswitch-2)
+      colch4(lswitch-1) = 0.
+      ch4_equ(lswitch-1) = 0.
+      do l = lswitch-2,1,-1
+         dp = (press(l) - press(l+1))*100.
+         colch4(l) = colch4(l+1) + (rmch4(l+1) + rmch4(l))*0.5 &
+                                 *6.022e22*dp/(zmmean(l)*g)
+         ch4_equ(l)=colch4(l)/col(l)
+!         tauch4(l)=1.8e-21*colch4(l)
+!         if(tauch4(l).ge.1.0) exit
+      end do
+!      ch4ref = (rmch4(l+1)*(tauch4(l)-1)+rmch4(l)*(1-tauch4(l+1))) &
+!                                 /(tauch4(l)-tauch4(l+1))
+
+!     2) interpolation in CH4
+
+!      ch4ref = min(ch4ref,table_ch4(nch4))
+!      ch4ref = max(ch4ref,table_ch4(1))
+
+!      indch4 = nch4 - 1
+!      do ich4 = 1,nch4
+!         if (table_ch4(ich4) >= ch4ref) then
+!            indch4 = ich4 - 1
+!            indch4 = max(indch4, 1)
+!            exit
+!         end if
+!      end do
+!      cich4 = (ch4ref - table_ch4(indch4))     &
+!             /(table_ch4(indch4 + 1) - table_ch4(indch4))
+
+
 
 !==========================================================================
@@ -169,12 +238,19 @@
       tref = max(tref,table_temp(ntemp))
 
-      do it = 2, ntemp
-         if (table_temp(it) <= tref) then
-            citemp = (log(tref) - log(table_temp(it)))              &
-                    /(log(table_temp(it-1)) - log(table_temp(it)))
-            indtemp = it - 1
-            exit
-         end if
-      end do
+      if(ntemp.eq.1) then
+        citemp = 1.
+        indtemp = 1
+      else
+        do it = 2, ntemp
+           if (table_temp(it) <= tref) then
+              citemp = (log(tref) - log(table_temp(it)))              &
+                      /(log(table_temp(it-1)) - log(table_temp(it)))
+              indtemp = it - 1
+              exit
+           end if
+        end do
+      endif
+
+
 
 !==========================================================================
@@ -200,5 +276,5 @@
          indozo = nozo - 1
          do iozo = 1,nozo
-            if (table_ozo(iozo)*10. >= ratio_o3(l)) then
+            if (table_ozo(iozo) >= ratio_o3(l)) then
                indozo = iozo - 1
                indozo = max(indozo, 1)
